"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getBinanceOpenOrdersStream = void 0;
var operators_1 = require("rxjs/operators");
var private_ws_handler_1 = require("../ws_clients/private_ws_handler");
var getBinanceOpenOrdersStream = function (lastToken, injectedApiKeys) { return __awaiter(void 0, void 0, void 0, function () {
    var privateObservable$;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, private_ws_handler_1.getBinancePrivateObservableFromWS(lastToken, ['executionReport'], function (_a) {
                    var eventType = _a.e;
                    return ['executionReport'].includes(eventType);
                }, null, injectedApiKeys)];
            case 1:
                privateObservable$ = (_a.sent()).privateObservable$;
                return [2 /*return*/, privateObservable$.pipe(operators_1.map(function (_a) {
                        var eventType = _a.e, eventTime = _a.E, symbol = _a.s, clientOrderId = _a.c, side = _a.S, orderType = _a.o, timeInForce = _a.f, orderQuantity = _a.q, orderPrice = _a.p, stopPrice = _a.P, icebergQuantity = _a.F, orderListId = _a.g, canceledOrderId = _a.C, executionType = _a.x, executionStatus = _a.X, rejectReason = _a.r, orderId = _a.i, lastExecutedQuantity = _a.l, cumulativeFilledQuantity = _a.z, lastExecutedPrice = _a.L, comissionAmount = _a.n, comissionAsset = _a.N, transactionTime = _a.T, tradeID = _a.t, ignore = _a.I, isOrderOnBook = _a.w, isMakerTrade = _a.m, orderCreationTime = _a.O, cumulativeQuoteQty = _a.Z, lastQuoteAssetTransactedQuantity = _a.Y, quoteOrderQty = _a.Q;
                        return ({
                            eventType: eventType,
                            eventTime: eventTime,
                            symbol: symbol,
                            clientOrderId: clientOrderId,
                            side: side,
                            orderType: orderType,
                            timeInForce: timeInForce,
                            orderQuantity: orderQuantity,
                            orderPrice: orderPrice,
                            stopPrice: stopPrice,
                            icebergQuantity: icebergQuantity,
                            orderListId: orderListId,
                            canceledOrderId: canceledOrderId,
                            executionType: executionType,
                            executionStatus: executionStatus,
                            rejectReason: rejectReason,
                            orderId: orderId,
                            lastExecutedQuantity: lastExecutedQuantity,
                            cumulativeFilledQuantity: cumulativeFilledQuantity,
                            lastExecutedPrice: lastExecutedPrice,
                            comissionAmount: comissionAmount,
                            comissionAsset: comissionAsset,
                            transactionTime: transactionTime,
                            tradeID: tradeID,
                            ignore: ignore,
                            isOrderOnBook: isOrderOnBook,
                            isMakerTrade: isMakerTrade,
                            orderCreationTime: orderCreationTime,
                            cumulativeQuoteQty: cumulativeQuoteQty,
                            lastQuoteAssetTransactedQuantity: lastQuoteAssetTransactedQuantity,
                            quoteOrderQty: quoteOrderQty
                        });
                    }))];
        }
    });
}); };
exports.getBinanceOpenOrdersStream = getBinanceOpenOrdersStream;
