export declare type BinanceUserDataEventType = 'balanceUpdate' | 'outboundAccountPosition' | 'executionReport';
export declare type BinanceOpenOrderSnapshot = {
    eventType: BinanceUserDataEventType;
    eventTime: number;
    symbol: string;
    clientOrderId: string;
    side: 'BUY' | 'SELL';
    orderType: string;
    timeInForce: string;
    orderQuantity: string;
    orderPrice: string;
    stopPrice: string;
    icebergQuantity: string;
    orderListId: number;
    canceledOrderId: string;
    executionType: string;
    executionStatus: string;
    rejectReason: string;
    orderId: number;
    lastExecutedQuantity: string;
    cumulativeFilledQuantity: string;
    lastExecutedPrice: string;
    comissionAmount: string;
    comissionAsset: string | null;
    transactionTime: number;
    tradeID: number;
    isOrderOnBook: boolean;
    isMakerTrade: boolean;
    orderCreationTime: number;
    cumulativeQuoteQty: string;
    lastQuoteAssetTransactedQuantity: string;
    quoteOrderQty: string;
};
