"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.onBinancePublicWSClosed = exports.onBinancePublicWSOpened = exports.getBinancePublicObservableFromWS = void 0;
/* eslint-disable @typescript-eslint/no-use-before-define */
var ws_1 = __importDefault(require("ws"));
var webSocket_1 = require("rxjs/webSocket");
var binance_axios_config_1 = require("../binance_axios_config");
var Subject_1 = require("rxjs/internal/Subject");
var onBinancePublicWSOpened = new Subject_1.Subject();
exports.onBinancePublicWSOpened = onBinancePublicWSOpened;
var onBinancePublicWSClosed = new Subject_1.Subject();
exports.onBinancePublicWSClosed = onBinancePublicWSClosed;
var binancePublicWS = webSocket_1.webSocket({
    url: binance_axios_config_1.baseWsURL + "/stream",
    WebSocketCtor: ws_1.default,
    openObserver: onBinancePublicWSOpened,
    closeObserver: onBinancePublicWSClosed
});
var getBinancePublicObservableFromWS = function (streamNames, filterFn, unsubscriptionData) {
    if (filterFn === void 0) { filterFn = function (_a) {
        var _b = _a.stream, stream = _b === void 0 ? '' : _b;
        return streamNames.includes(stream);
    }; }
    var subscriptionData = {
        method: "SUBSCRIBE",
        params: streamNames,
        id: new Date().getTime()
    };
    var publicObservable$ = binancePublicWS.multiplex(function () { return subscriptionData; }, function () { return unsubscriptionData; }, filterFn);
    return publicObservable$;
};
exports.getBinancePublicObservableFromWS = getBinancePublicObservableFromWS;
