#!/usr/bin/env node
'use strict';
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var dotenv_1 = __importDefault(require("dotenv"));
dotenv_1.default.config();
var fs_1 = require("fs");
var path_1 = require("path");
var debug_helper_1 = __importDefault(require("./util/debug_helper"));
var print = debug_helper_1.default(__filename).print;
var _a = process.argv, arg1 = _a[1], arg2 = _a[2];
var argsStr = [arg1, arg2].join(' ');
var _b = JSON.parse(fs_1.readFileSync(path_1.resolve(__dirname, '..', 'package.json')).toString()), name = _b.name, version = _b.version;
if (/\s-v\s*$/.test(argsStr)) {
    console.log("    " + name + " v" + version + " \u2714\uFE0F");
    process.exit();
}
var node_menu_1 = __importDefault(require("node-menu"));
var private_api_request_1 = require("./kraken/api_clients/private_api_request");
var private_api_request_2 = require("./hitbtc/api_clients/private_api_request");
var private_api_request_3 = require("./binance/api_clients/private_api_request");
var get_binance_price_ticker_1 = require("./binance/services/get_binance_price_ticker");
var get_binance_ohlc_candles_1 = require("./binance/services/get_binance_ohlc_candles");
var get_kraken_price_ticker_1 = require("./kraken/services/get_kraken_price_ticker");
var get_kraken_ohlc_candles_1 = require("./kraken/services/get_kraken_ohlc_candles");
var get_hitbtc_price_ticker_1 = require("./hitbtc/services/get_hitbtc_price_ticker");
var get_hitbtc_ohlc_candles_1 = require("./hitbtc/services/get_hitbtc_ohlc_candles");
var filter_balances_1 = require("./util/filter_balances");
var handle_user_input_1 = __importDefault(require("./util/handle_user_input"));
node_menu_1.default
    .customHeader(function () {
    process.stdout.write("                              <<<<<<     TS-CRYPTO-CLI v" + version + "     >>>>>>\n");
})
    // 
    // KRAKEN
    // 
    .addDelimiter('\n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n#    Kraken API | https://www.kraken.com/features/api#general-usage \n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~', 2)
    .addItem('PUBLIC API request', function (input) { var _a = input.split(' '), endpoint = _a[0], params = _a[1]; handle_user_input_1.default(endpoint, 'POST', 'kraken', 'public', params); }, null, [{ name: 'endpoint params"  -->  i.e.  1 "Ticker pair=XBTUSDT', type: 'string' }])
    .addItem('Get last OHLC candle', function (symbol) { return __awaiter(void 0, void 0, void 0, function () { var _a; return __generator(this, function (_b) {
    switch (_b.label) {
        case 0:
            _a = print;
            return [4 /*yield*/, get_kraken_ohlc_candles_1.getKrakenOHLCCandles(symbol)];
        case 1:
            _a.apply(void 0, [(_b.sent())[0]]);
            return [2 /*return*/];
    }
}); }); }, null, [{ name: 'symbol"  -->  i.e.  2 "XBTUSDT', type: 'string' }])
    .addItem('Get price ticker', function (symbol) { return __awaiter(void 0, void 0, void 0, function () { var _a; return __generator(this, function (_b) {
    switch (_b.label) {
        case 0:
            _a = print;
            return [4 /*yield*/, get_kraken_price_ticker_1.getKrakenPriceTicker(symbol)];
        case 1:
            _a.apply(void 0, [_b.sent()]);
            return [2 /*return*/];
    }
}); }); }, null, [{ name: 'symbol"  -->  i.e.  3 "XBTUSDT', type: 'string' }])
    .addDelimiter(' ', 1)
    .addItem('PRIVATE API request', function (input) { var _a = input.split(' '), endpoint = _a[0], params = _a[1]; handle_user_input_1.default(endpoint, 'POST', 'kraken', 'private', params); }, null, [{ name: 'endpoint params"  -->  i.e.  4 "DepositMethods asset=XBT', type: 'string' }])
    .addItem('Load Kraken API credentials', function (input) { var _a = input.split(' '), k = _a[0], s = _a[1]; process.env.KRAKEN_API_KEY = k; process.env.KRAKEN_API_SECRET = s; private_api_request_1.updateKrakenDefaultClient(k, s); }, null, [{ name: 'api-key api-secret"  -->  i.e.  5 "KRAKEN-API-KEY KRAKEN-API-SECRET', type: 'string' }])
    .addItem('Show Kraken API credentials in use', function () { print({ apiKey: process.env.KRAKEN_API_KEY, apiSecret: process.env.KRAKEN_API_SECRET }); })
    .addItem('Show Balances', function () { return __awaiter(void 0, void 0, void 0, function () { var _a, _b; return __generator(this, function (_c) {
    switch (_c.label) {
        case 0:
            _a = print;
            _b = filter_balances_1.filterKrakenBalances;
            return [4 /*yield*/, private_api_request_1.krakenPrivateApiRequest({ url: 'Balance' })];
        case 1:
            _a.apply(void 0, [_b.apply(void 0, [_c.sent()])]);
            return [2 /*return*/];
    }
}); }); })
    .addItem('BUY @ market', function (input) { return __awaiter(void 0, void 0, void 0, function () { var _a, pair, volume, _b; return __generator(this, function (_c) {
    switch (_c.label) {
        case 0:
            _a = input.split(' '), pair = _a[0], volume = _a[1];
            _b = print;
            return [4 /*yield*/, private_api_request_1.krakenPrivateApiRequest({ url: 'AddOrder', data: { pair: pair, type: 'buy', ordertype: 'market', volume: volume } })];
        case 1:
            _b.apply(void 0, [_c.sent()]);
            return [2 /*return*/];
    }
}); }); }, null, [{ name: 'pair amount"  -->  i.e.  8 "XBTUSDT 0.001', type: 'string' }])
    .addItem('SELL @ market', function (input) { return __awaiter(void 0, void 0, void 0, function () { var _a, pair, volume, _b; return __generator(this, function (_c) {
    switch (_c.label) {
        case 0:
            _a = input.split(' '), pair = _a[0], volume = _a[1];
            _b = print;
            return [4 /*yield*/, private_api_request_1.krakenPrivateApiRequest({ url: 'AddOrder', data: { pair: pair, type: 'sell', ordertype: 'market', volume: volume } })];
        case 1:
            _b.apply(void 0, [_c.sent()]);
            return [2 /*return*/];
    }
}); }); }, null, [{ name: 'pair amount"  -->  i.e.  9 "XBTUSDT 0.001', type: 'string' }])
    // 
    // HITBTC
    // 
    .addDelimiter('\n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n#    HitBTC API | https://api.hitbtc.com/#rest-api-reference \n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~', 2)
    .addItem('PUBLIC API request', function (input) { var _a = input.split(' '), method = _a[0], endpoint = _a[1], params = _a[2]; handle_user_input_1.default(endpoint, method, 'hitbtc', 'public', params); }, null, [{ name: 'method endpoint params"  -->  i.e.  10 "GET currency currencies=BTC,USD', type: 'string' }])
    .addItem('Get last OHLC candle', function (symbol) { return __awaiter(void 0, void 0, void 0, function () { var _a; return __generator(this, function (_b) {
    switch (_b.label) {
        case 0:
            _a = print;
            return [4 /*yield*/, get_hitbtc_ohlc_candles_1.getHitBTCOHLCCandles(symbol)];
        case 1:
            _a.apply(void 0, [(_b.sent())[0]]);
            return [2 /*return*/];
    }
}); }); }, null, [{ name: 'symbol"  -->  i.e.  11 "BTCUSD', type: 'string' }])
    .addItem('Get price ticker', function (symbol) { return __awaiter(void 0, void 0, void 0, function () { var _a; return __generator(this, function (_b) {
    switch (_b.label) {
        case 0:
            _a = print;
            return [4 /*yield*/, get_hitbtc_price_ticker_1.getHitBTCPriceTicker(symbol)];
        case 1:
            _a.apply(void 0, [_b.sent()]);
            return [2 /*return*/];
    }
}); }); }, null, [{ name: 'symbol"  -->  i.e.  12 "BTCUSD', type: 'string' }])
    .addDelimiter(' ', 1)
    .addItem('PRIVATE API request', function (input) { var _a = input.split(' '), method = _a[0], endpoint = _a[1], params = _a[2]; handle_user_input_1.default(endpoint, method, 'hitbtc', 'private', params); }, null, [{ name: 'method endpoint params"  -->  i.e.  13 "GET account/transactions currency=BTC', type: 'string' }])
    .addItem('Load HitBTC API credentials', function (input) { var _a = input.split(' '), k = _a[0], s = _a[1]; process.env.HITBTC_API_KEY = k; process.env.HITBTC_API_SECRET = s; private_api_request_2.updateHitBTCDefaultClient(k, s); }, null, [{ name: 'api-key api-secret"  -->  i.e.  14 "HITBTC-API-KEY HITBTC-API-SECRET', type: 'string' }])
    .addItem('Show HitBTC API credentials in use', function () { print({ apiKey: process.env.HITBTC_API_KEY, apiSecret: process.env.HITBTC_API_SECRET }); })
    .addItem('Show ACCOUNT Balances', function () { return __awaiter(void 0, void 0, void 0, function () { var _a, _b; return __generator(this, function (_c) {
    switch (_c.label) {
        case 0:
            _a = print;
            _b = filter_balances_1.filterHitBTCBalances;
            return [4 /*yield*/, private_api_request_2.hitbtcPrivateApiRequest({ url: 'account/balance' })];
        case 1:
            _a.apply(void 0, [_b.apply(void 0, [_c.sent()])]);
            return [2 /*return*/];
    }
}); }); })
    .addItem('Show TRADING Balances', function () { return __awaiter(void 0, void 0, void 0, function () { var _a, _b; return __generator(this, function (_c) {
    switch (_c.label) {
        case 0:
            _a = print;
            _b = filter_balances_1.filterHitBTCBalances;
            return [4 /*yield*/, private_api_request_2.hitbtcPrivateApiRequest({ url: 'trading/balance' })];
        case 1:
            _a.apply(void 0, [_b.apply(void 0, [_c.sent()])]);
            return [2 /*return*/];
    }
}); }); })
    .addItem('BUY @ market', function (input) { return __awaiter(void 0, void 0, void 0, function () { var _a, symbol, quantity, _b; return __generator(this, function (_c) {
    switch (_c.label) {
        case 0:
            _a = input.split(' '), symbol = _a[0], quantity = _a[1];
            _b = print;
            return [4 /*yield*/, private_api_request_2.hitbtcPrivateApiRequest({ url: 'order', method: 'POST', data: { symbol: symbol, side: 'buy', type: 'market', quantity: quantity } })];
        case 1:
            _b.apply(void 0, [_c.sent()]);
            return [2 /*return*/];
    }
}); }); }, null, [{ name: 'symbol quantity"  -->  i.e.  18 "BTCUSD 0.0015', type: 'string' }])
    .addItem('SELL @ market', function (input) { return __awaiter(void 0, void 0, void 0, function () { var _a, symbol, quantity, _b; return __generator(this, function (_c) {
    switch (_c.label) {
        case 0:
            _a = input.split(' '), symbol = _a[0], quantity = _a[1];
            _b = print;
            return [4 /*yield*/, private_api_request_2.hitbtcPrivateApiRequest({ url: 'order', method: 'POST', data: { symbol: symbol, side: 'sell', type: 'market', quantity: quantity } })];
        case 1:
            _b.apply(void 0, [_c.sent()]);
            return [2 /*return*/];
    }
}); }); }, null, [{ name: 'symbol quantity"  -->  i.e.  19 "BTCUSD 0.0015', type: 'string' }])
    // 
    // BINANCE
    // 
    .addDelimiter('\n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n#    Binance API | https://binance-docs.github.io/apidocs/spot/en/#general-api-information \n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~', 2)
    .addItem('PUBLIC API request', function (input) { var _a = input.split(' '), method = _a[0], endpoint = _a[1], params = _a[2]; handle_user_input_1.default(endpoint, method, 'binance', 'public', params); }, null, [{ name: 'method endpoint params"  -->  i.e.  20 "GET api/v3/avgPrice symbol=BTCUSDT', type: 'string' }])
    .addItem('Get last OHLC candle', function (symbol) { return __awaiter(void 0, void 0, void 0, function () { var _a; return __generator(this, function (_b) {
    switch (_b.label) {
        case 0:
            _a = print;
            return [4 /*yield*/, get_binance_ohlc_candles_1.getBinanceOHLCCandles(symbol)];
        case 1:
            _a.apply(void 0, [(_b.sent())[0]]);
            return [2 /*return*/];
    }
}); }); }, null, [{ name: 'symbol"  -->  i.e.  21 "BTCUSDT', type: 'string' }])
    .addItem('Get price ticker', function (symbol) { return __awaiter(void 0, void 0, void 0, function () { var _a; return __generator(this, function (_b) {
    switch (_b.label) {
        case 0:
            _a = print;
            return [4 /*yield*/, get_binance_price_ticker_1.getBinancePriceTicker(symbol)];
        case 1:
            _a.apply(void 0, [_b.sent()]);
            return [2 /*return*/];
    }
}); }); }, null, [{ name: 'symbol"  -->  i.e.  22 "BTCUSDT', type: 'string' }])
    .addDelimiter(' ', 1)
    .addItem('PRIVATE API request', function (input) { var _a = input.split(' '), method = _a[0], endpoint = _a[1], params = _a[2]; handle_user_input_1.default(endpoint, method, 'binance', 'private', params); }, null, [{ name: 'method endpoint params"  -->  i.e.  23 "GET api/v3/allOrders symbol=BTCUSDT&limit=100', type: 'string' }])
    .addItem('Load Binance API credentials', function (input) { var _a = input.split(' '), k = _a[0], s = _a[1]; process.env.BINANCE_API_KEY = k; process.env.BINANCE_API_SECRET = s; private_api_request_3.updateBinanceDefaultClient(k, s); }, null, [{ name: 'api-key api-secret"  -->  i.e.  24 "BINANCE-API-KEY BINANCE-API-SECRET', type: 'string' }])
    .addItem('Show Binance API credentials in use', function () { print({ apiKey: process.env.BINANCE_API_KEY, apiSecret: process.env.BINANCE_API_SECRET }); })
    .addItem('Show Balances', function () { return __awaiter(void 0, void 0, void 0, function () { var _a, _b; return __generator(this, function (_c) {
    switch (_c.label) {
        case 0:
            _a = print;
            _b = filter_balances_1.filterBinanceBalances;
            return [4 /*yield*/, private_api_request_3.binancePrivateApiRequest({ url: 'api/v3/account' })];
        case 1:
            _a.apply(void 0, [_b.apply(void 0, [(_c.sent()).balances])]);
            return [2 /*return*/];
    }
}); }); })
    .addItem('BUY @ market', function (input) { return __awaiter(void 0, void 0, void 0, function () { var _a, symbol, quantity, _b; return __generator(this, function (_c) {
    switch (_c.label) {
        case 0:
            _a = input.split(' '), symbol = _a[0], quantity = _a[1];
            _b = print;
            return [4 /*yield*/, private_api_request_3.binancePrivateApiRequest({ url: 'api/v3/order', method: 'POST', data: { symbol: symbol, side: 'buy', type: 'market', quantity: quantity } })];
        case 1:
            _b.apply(void 0, [_c.sent()]);
            return [2 /*return*/];
    }
}); }); }, null, [{ name: 'symbol quantity"  -->  i.e.  27 "BTCUSDT 0.0015', type: 'string' }])
    .addItem('SELL @ market', function (input) { return __awaiter(void 0, void 0, void 0, function () { var _a, symbol, quantity, _b; return __generator(this, function (_c) {
    switch (_c.label) {
        case 0:
            _a = input.split(' '), symbol = _a[0], quantity = _a[1];
            _b = print;
            return [4 /*yield*/, private_api_request_3.binancePrivateApiRequest({ url: 'api/v3/order', method: 'POST', data: { symbol: symbol, side: 'sell', type: 'market', quantity: quantity } })];
        case 1:
            _b.apply(void 0, [_c.sent()]);
            return [2 /*return*/];
    }
}); }); }, null, [{ name: 'symbol quantity"  -->  i.e.  28 "BTCUSDT 0.0015', type: 'string' }])
    .addDelimiter(' ', 1)
    .customPrompt(function () {
    process.stdout.write('\n\nEnter your selection:\n');
})
    .continueCallback(function () {
    // Runs between 'Press enter to continue' and the new menu render
})
    .start();
