"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.onHitBTCWSClosed = exports.onHitBTCWSOpened = exports.getHitBTCPublicObservableFromWS = void 0;
var ws_1 = __importDefault(require("ws"));
var webSocket_1 = require("rxjs/webSocket");
var hitbtc_axios_config_1 = require("../../hitbtc/hitbtc_axios_config");
var Subject_1 = require("rxjs/internal/Subject");
var onHitBTCWSOpened = new Subject_1.Subject();
exports.onHitBTCWSOpened = onHitBTCWSOpened;
var onHitBTCWSClosed = new Subject_1.Subject();
exports.onHitBTCWSClosed = onHitBTCWSClosed;
var hitBTCWS = webSocket_1.webSocket({
    protocol: 'v1',
    url: hitbtc_axios_config_1.baseWsURL,
    WebSocketCtor: ws_1.default,
    openObserver: onHitBTCWSOpened,
    closeObserver: onHitBTCWSClosed
});
var getHitBTCPublicObservableFromWS = function (subscriptionData, filterFn, unsubscriptionData) {
    var publicObservable$ = hitBTCWS.multiplex(function () { return subscriptionData; }, function () { return unsubscriptionData; }, filterFn);
    return publicObservable$;
};
exports.getHitBTCPublicObservableFromWS = getHitBTCPublicObservableFromWS;
