"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getKrakenTickerStream = void 0;
var operators_1 = require("rxjs/operators");
var public_ws_handler_1 = require("./../ws_clients/public_ws_handler");
var getKrakenTickerStream = function (baseAsset, quoteAsset) {
    var pair = (baseAsset + "/" + quoteAsset).toUpperCase();
    var subscribeData = {
        event: 'subscribe',
        pair: [pair],
        subscription: {
            name: 'ticker'
        }
    };
    var unsubscribeData = {
        event: 'unsubscribe',
        pair: [pair],
        subscription: {
            name: 'ticker'
        }
    };
    var filterStream = function (response) { return Array.isArray(response) && response.slice(-2).every(function (v) { return ['ticker', pair].includes(v); }); };
    return public_ws_handler_1.getKrakenPublicObservableFromWS(subscribeData, filterStream, unsubscribeData).pipe(operators_1.map(function (_a) {
        var _b = _a[1], _c = (_b === void 0 ? {} : _b).c, _d = (_c === void 0 ? [] : _c)[0], price = _d === void 0 ? '' : _d;
        return ({
            exchange: 'kraken',
            utcTimestamp: new Date().getTime(),
            pair: pair,
            price: price,
        });
    }));
};
exports.getKrakenTickerStream = getKrakenTickerStream;
