"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getKrakenPrivateObservableFromWS = exports.gethWsAuthToken = exports.krakenPrivateWS = void 0;
var ws_1 = __importDefault(require("ws"));
var webSocket_1 = require("rxjs/webSocket");
var private_api_request_1 = require("../api_clients/private_api_request");
var debug_helper_1 = __importDefault(require("../../util/debug_helper"));
var Subject_1 = require("rxjs/internal/Subject");
var logError = debug_helper_1.default(__filename).logError;
var onKrakenPrivateWSOpened = new Subject_1.Subject();
var onKrakenPrivateWSClosed = new Subject_1.Subject();
exports.krakenPrivateWS = webSocket_1.webSocket({
    protocol: 'v1',
    url: 'wss://ws-auth.kraken.com/',
    WebSocketCtor: ws_1.default,
    openObserver: onKrakenPrivateWSOpened,
    closeObserver: onKrakenPrivateWSClosed
});
exports.gethWsAuthToken = function (injectedApiKeys) { return __awaiter(void 0, void 0, void 0, function () {
    var token, _a, code, message;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                _b.trys.push([0, 2, , 3]);
                return [4 /*yield*/, private_api_request_1.krakenPrivateApiRequest({ url: 'GetWebSocketsToken' }, injectedApiKeys)
                    // debug({ token })
                ];
            case 1:
                token = (_b.sent()).token;
                // debug({ token })
                return [2 /*return*/, token];
            case 2:
                _a = _b.sent();
                code = _a.code, message = _a.message;
                logError({ code: code, message: message });
                return [2 /*return*/, 'tokenNetworkError'];
            case 3: return [2 /*return*/];
        }
    });
}); };
exports.getKrakenPrivateObservableFromWS = function (lastToken, subscriptionData, filterFn, unsubscriptionData, injectedApiKeys) { return __awaiter(void 0, void 0, void 0, function () {
    var token, _a, subscriptionDataWithToken, privateObservable$;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                _a = lastToken;
                if (_a) return [3 /*break*/, 2];
                return [4 /*yield*/, exports.gethWsAuthToken(injectedApiKeys)];
            case 1:
                _a = (_b.sent());
                _b.label = 2;
            case 2:
                token = _a;
                subscriptionDataWithToken = subscriptionData.subscription ? __assign(__assign({}, subscriptionData), { subscription: __assign(__assign({}, subscriptionData.subscription), { token: token }) }) : __assign(__assign({}, subscriptionData), { token: token });
                privateObservable$ = exports.krakenPrivateWS.multiplex(function () { return (subscriptionDataWithToken); }, function () { return (unsubscriptionData); }, filterFn);
                return [2 /*return*/, {
                        privateObservable$: privateObservable$,
                        token: token,
                        onKrakenPrivateWSOpened: onKrakenPrivateWSOpened,
                        onKrakenPrivateWSClosed: onKrakenPrivateWSClosed
                    }];
        }
    });
}); };
