"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.onKrakenPublicWSClosed = exports.onKrakenPublicWSOpened = exports.getKrakenPublicObservableFromWS = void 0;
var ws_1 = __importDefault(require("ws"));
var webSocket_1 = require("rxjs/webSocket");
var Subject_1 = require("rxjs/internal/Subject");
var onKrakenPublicWSOpened = new Subject_1.Subject();
exports.onKrakenPublicWSOpened = onKrakenPublicWSOpened;
var onKrakenPublicWSClosed = new Subject_1.Subject();
exports.onKrakenPublicWSClosed = onKrakenPublicWSClosed;
var krakenPublicWS = webSocket_1.webSocket({
    protocol: 'v1',
    url: 'wss://ws.kraken.com',
    WebSocketCtor: ws_1.default,
    openObserver: onKrakenPublicWSOpened,
    closeObserver: onKrakenPublicWSClosed
});
var getKrakenPublicObservableFromWS = function (subscriptionData, filterFn, unsubscriptionData) {
    var publicObservable$ = krakenPublicWS.multiplex(function () { return subscriptionData; }, function () { return unsubscriptionData; }, filterFn);
    return publicObservable$;
};
exports.getKrakenPublicObservableFromWS = getKrakenPublicObservableFromWS;
